; `on awareness about the global extinction of bees, clear skies and global urbanisation, in 96byte' - 96b-tro for lovebyte
; spkr@smfx.st 2021

; constants for the image sprite in tos rom address space (bomb and bee, but we chose bee)
; constants for the used palette address in tos rom address space
TOS102		equ $00FC0DFA
TOS102BEE	equ $00FD649E
TOS102COL	equ $00FC17E8

TOS104		equ $00FC0DA2
TOS104BEE	equ $00FEC426
TOS104COL	equ $00FC0F9C

TOS106		equ $00E00F3E
TOS106BEE	equ $00E2E3B4
TOS106COL	equ	$00E01142

TOS162		equ $00E00F3E
TOS162BEE	equ $00E2E490
TOS162COL	equ $00E01142		

TOS205		equ $00E01054
TOS205BEE	equ $00E35740
TOS205COL	equ $00E02EA4

TOS206		equ $00E013B2
TOS206BEE	equ $00E37442
TOS206COL	equ $00E03852

; constants of which tos to use
CUR_TOS	equ TOS162BEE						; assemble for specific tos version here
CUR_COL	equ	TOS162COL

FINDBEE		equ 1						; flag to search for bee image in tos rom, to find hardcoded addresses
FINDCOLOUR	equ 1						; flag to find colour schemes from tos rom, that have $0 bg and col 15

	move.w	#$20,-(sp)					;4		shortest way to execute code; not correcting the stack
	trap 	#1							;2		lets go

	IFEQ	FINDBEE
	lea		.bee,a0
	lea		$e00000+2,a1
	movem.w	(a0)+,d0-d6
.find
		sub.w	#2,a1
.find2
		cmp.w	(a1)+,d0
		bne		.find2
			cmp.w	(a1)+,d1
			bne		.find
				cmp.w	(a1)+,d2
				bne		.find
					cmp.w	(a1)+,d3
					bne		.find
						cmp.w	(a1)+,d4
						bne		.find
							cmp.w	(a1)+,d5
							bne		.find
								cmp.w	(a1)+,d6
								bne		.find
									lea		-14(a1),a0
									move.b	#0,$ffffc123
	ENDC
	IFEQ	FINDCOLOUR
	move.w	#3000,.times
	ENDC


	dc.w	$a000						;2		line-a init
	sf      -6(A0)						;4		remove cursor, thanks ggn
	move.l	#CUR_COL,$45a.w				;8		set the address for the palette thats set next vbl, used in innerloop to drag the draw speed
.loop
;--- load sprite address and prep screen address
	lea		CUR_TOS,a0					;6		load the address of the bombsprite for the current tos to a0
	move.l	$00044E.w,a1				;4		move the address of the current physical screen pointer to a1
	lea		-4000+800+320(a1),a1		;4		adjust the screen pointer so that we dont crash, but also, such that the whole screen is reached; except the bottom :P
	moveq	#15-1,d7					;2		sprite-height (16)	
;--- start drawing bomb sprite
	move.w	a4,d2						;2		a4 inits at 0, and is the x-position
.height
		move.w	(a0)+,d0				;2		get sprite data, 16 pixels
		moveq	#0,d1					;2		clear out the 2nd 16 pixels, which are used for shifted pixels that cross first word boundary
		move.w	d5,d6					;2		d5 holds the number of shifts to be performed
.x_shift
			move.w	d2,d5				;2		move d2 to local d5 for next iteration, so we introduce distortion over y lines
			and.w	#$f,d5				;4		nr of shifts 0..15
			and.w	#-2,d2				;4		even stepping for x value, so we draw in multiple colors when added to screen offset
			asr.w	d0					;2		shift pixel right			
			roxr.w	d1					;2		shift pixel right and shift extend
		dbra	d6,.x_shift				;4		loop over the number of shifts	
		or.w	d0,(a1,d3.w)			;4		draw first 16 pixels
		or.w	d1,8(a1,d3.w)			;4		draw next 16 pixels
		lea		160(a1),a1				;4		increase screen pointer to next scanline
	dbra	d7,.height					;4		loop over sprite-height (16)
;--- adjust x,y positions
	addq.w	#3,d3						;2		d3 holds value for y position of the sprite, we add 3 each loop
	mulu	d3,d3						;2		y_pos = y_pos^2 for some less lineair movement
	muls	#160,d3						;4		we multiply by 160, since scanline width is 160 bytes, and we only use the lower value; so all good
	
	addq.w	#7,a4						;2		a4 holds value for x position
	add.w	d2,d3						;2		d2 holds value for x offset determined by x position 
	IFNE	FINDCOLOUR
	bra.s		.loop					;2		endless loop
	ELSE
	subq.w	#1,.times
	bge		.loop
	ENDC
.padding	
	dc.b	"smfx"						;4		padding to get to 96 bytes
	IFEQ	FINDCOLOUR
	lea		$00E00000,a0
.next
	move.w	(a0)+,d0
	bne		.next
		cmp.w	#0,28(a0)
		bne		.next
			lea		-2(a0),a1
			move.l	a1,$45a.w
			move.b	#0,$ffffc123
			move.l	a1,a6
			move.w	#16000,d7
.xx
				divs	d6,d6
				dbra	d7,.xx
			jmp		.next
.times	dc.w	0
	ENDC

	IFEQ	FINDBEE
.bee
	dc.w	%0000100000000000
	dc.w	%0000100000111100
	dc.w	%0000000001100010
	dc.w	%0000011011000010
	dc.w	%1100011010000100
	dc.w	%0001100110001010
	dc.w	%0001101101010100
	ENDC

